' *********************************************************
' * bilder.bas            Eastler              1.Mai 2008 *
' *********************************************************
' * Dieses Upro liest Bilddateien (Bmp) in den Ram ein    *
' * und stellt diese dann (Bmp-Pointer) zur Verfgung.    *
' *                                                       *
' * Sinn und Zweck ist dabei, da ein und dasselbe Bild   *
' * nur einmal eingelesen wird (Ram verbraucht wird)      *
' * auch wenn mehrere Subs dieses Bild verwenden.         *
' *                                                       *
' * einfach "GibBildPtr" mit Dateiname aufrufen,          *
' * diese Funktion gibt den pointer auf dieses Bild zurck*
' *                                                       *
' * Dabei prft die Routine, ob anhand des bergebenen    *
' * Dateinamens, ob dieses Bild bereits im Speicher steht *
' * und liest ggf. diese Datei ein.                       *
' *********************************************************
DECLARE FUNCTION Bild (was AS STRING, Datei AS STRING) AS ANY PTR
TYPE BildDaten
   Pointer AS ANY PTR
   Dateiname AS STRING * 128
   Breite AS INTEGER
   Hoehe  AS INTEGER
END TYPE

FUNCTION Bild (was AS STRING, Datei AS STRING) AS ANY PTR
   STATIC AS BildDaten Bilder(100)
   STATIC AS INTEGER BilderAngelegt, BilderLfnr, BilderFlag, BilderFreeFile

   SELECT CASE UCASE(was)
      CASE "GIBBILDPTR"
         'erst mal alle bereits gelesenen Bilder durchgehen,
         'ob dieser Dateiname schon eingelesen ist
         BilderFlag=0
         FOR BilderLfnr = 0 TO BilderAngelegt
            IF Bilder(BilderLfnr).Dateiname = Datei THEN BilderFlag = BilderLfnr
         NEXT BilderLfnr
         IF BilderFlag = 0 THEN
            'Bilddatei noch nicht im Ram, also einlesen
            IF BilderAngelegt < UBOUND(Bilder) THEN
                BilderFreeFile = FREEFILE
                'existiert die Datei berhaupt? Falls ja, dann Breite und Hhe holen, ImgCreate und Einlesen
                Open Datei FOR INPUT AS #BilderFreeFile
                IF LOF(BilderFreeFile) > 0 THEN
                   BilderAngelegt = BilderAngelegt + 1
                   Get #BilderFreeFile, 19, Bilder(BilderAngelegt).Breite  'Breite aus der BMP-Datei auslesen
                   Get #BilderFreeFile, 23, Bilder(BilderAngelegt).Hoehe   'Hhe aus der BMP-Datei auslesen
                   Bilder(BilderAngelegt).Dateiname = Datei
                   Bilder(BilderAngelegt).Pointer = IMAGECREATE(Bilder(BilderAngelegt).Breite, Bilder(BilderAngelegt).Hoehe)
                   CLOSE BilderFreeFile
                   IF Bilder(BilderAngelegt).Pointer = 0 THEN
                      'mit Imagecreate konnte kein Ram reserviert werden
                      CLS
                      PRINT "Function Bilder: Soll das Bild"
                      PRINT Datei & " in den Ram einlesen"
                      PRINT "Die Freebasic-Function IMAGECREATE gibt aber null zurueck"
                      PRINT "Es konnte kein Ram fr das Bild reserviert werden"
                      PRINT "Ram-Speicher zu knapp???"
                      PRINT "jegliche Taste = Programmende"
                      DO WHILE INKEY = ""
                      LOOP
                      END
                      SYSTEM
                   END IF
                   'Ram ist reserviert, Datei gibts tatschlich, also in Ram einlesen
                   BLOAD(  Datei,   Bilder(BilderAngelegt).Pointer  )
                   ' und die Bildnummer in Bilderflag fuer die Rueckgabe der Function
                   BilderFlag = BilderAngelegt
                ELSE
                   'Bilddatei hat groesse Null, existiert also nicht
                   CLOSE #BilderFreeFile
                   CLS
                   PRINT "Function Bilder: Soll das Bild"
                   PRINT Datei & " in den Ram einlesen"
                   PRINT "Die Datei scheint jedoch nicht zu existieren"
                   PRINT "jegliche Taste = Programmende"
                   DO WHILE INKEY = ""
                   LOOP
                   END
                   SYSTEM
                END IF
            ELSE
               'falls die maximalanzahl an Bildern (aus Static as Bilder( XXXX )) schon belegt,
               'hier Fehler bringen
               CLS
               PRINT "Function Bilder: Soll das Bild"
               PRINT Datei & " in den Ram einlesen"
               PRINT "Das waere dann das " & STR(UBOUND(Bilder)+1) & ".Bild"
               PRINT "Es wurde jedoch nur Platz fuer"
               PRINT STR(UBOUND(Bilder)) & "Bilder"
               PRINT "Gedimmt."
               PRINT "Programmierer informieren, im Quellcode"
               PRINT "in der Function bilder"
               PRINT "in der Zeile -STATIC AS BildDaten Bilder(100)"
               PRINT "mit hherer Anzahl dimmen!"
               PRINT "jegliche Taste = Programmende"
               DO WHILE INKEY = ""
               LOOP
               END
               SYSTEM
            END IF
         END IF
         bild = bilder(BilderFlag).Pointer
      CASE ELSE
   END SELECT
END FUNCTION