'===============================================================
'figure.Bas    alle SUBs und FUNCTIONs zur Steuerung der Figuren
'---------------------------------------------------------------
'erstellt Eastler 7.Jan 2008
'per Include in Hauptprogramm mit FreeBasic 0.182 zu kompilieren
'*************************************************************
'*                                                           *
'*    in CASE "LAUFEINSCHRITT" Ist Zeitkontrolle auf (FigNr) *
'*                                                           *
'*************************************************************

'===============================================================
'INITIALISIERUNGSBEREICH
'---------------------------------------------------------------
'DECLARES
DECLARE SUB Figur(Was AS STRING, FigNr AS INTEGER, StartPosX AS INTEGER, StartPosY AS INTEGER, FigurDateiName AS STRING)
'---------------------------------------------------------------
TYPE SortierArray
   ZPosY AS INTEGER
   ArrayPos AS INTEGER
END TYPE
TYPE FIGURDATEN
   Figurname AS STRING * 8     '###
   BildName  AS STRING * 25    '###
   SollBild  AS STRING * 25    '###
   BildAdr   AS ANY PTR     '###
   BildPal   AS ANY PTR        '###
   QStX      AS INTEGER        '### QuellStartX
   QStY      AS INTEGER        '### QuellStartY
   ZStX      AS INTEGER        '### ZielStartX
   ZStY      AS INTEGER        '### ZielStartY
   QPosX     AS INTEGER        '### QuellPosX
   QPosY     AS INTEGER        '### QuellPosY
   ZPosX     AS INTEGER        '### ZielPosX
   ZPosY     AS INTEGER        '### ZielPosY
   Breite    AS INTEGER        '### KopieBreite
   Hoehe     AS INTEGER        '### KopieHoehe
   LaufRchtg AS INTEGER
   XRcht     AS INTEGER        '### XRichtung
   YRcht     AS INTEGER        '### YRichtung
   WegQuelX  AS INTEGER        '### wo die Figur her kommt X-Koordinate
   WegQuelY  AS INTEGER        '### wo die Figur her kommt Y-Koordinate
   WegZielX  AS INTEGER        '### wo die Figur Hin soll X-Koordinate
   WegZielY  AS INTEGER        '### wo die Figur Hin soll Y-Koordinate
   LTimer    AS DOUBLE         '### LetztGelaufenTimer
   XStep     AS DOUBLE         '### XSpeed
   YStep     AS DOUBLE         '### YSpeed
   RepSecs   AS DOUBLE         '### LaufSpeed
   InitFlag  AS INTEGER        '### FigurInitFlag
   FrameNr   AS INTEGER        '### Zaelhler
   FrameBreit AS INTEGER
   FrameHoch AS INTEGER
   FrameZahl AS INTEGER
   IstAktiv  AS INTEGER  'neu, fr ist Angeklickt also grner Strich drber oder so
   Sichtbar  AS INTEGER  ' neu um unsichtbar zu ermglichen
END TYPE

DIM SHARED FG(1024) AS FIGURDATEN
DIM SHARED SortArray(1024) AS SortierArray
DIM SHARED Figurenbestand(10) AS FIGURDATEN

Figurenbestand(1).Figurname="tarzan01" : Figurenbestand(1).XStep = 2 : Figurenbestand(1).YStep = 1
Figurenbestand(2).Figurname="blauzyli" : Figurenbestand(2).XStep = 2 : Figurenbestand(2).YStep = 1
Figurenbestand(3).Figurname="gelbzyli" : Figurenbestand(3).XStep = 2 : Figurenbestand(3).YStep = 1
Figurenbestand(4).Figurname="hottehue" : Figurenbestand(4).XStep = 2 : Figurenbestand(4).YStep = 1
Figurenbestand(5).Figurname="blaukuge" : Figurenbestand(5).XStep = 2 : Figurenbestand(5).YStep = 1
Figurenbestand(6).Figurname="rotekuge" : Figurenbestand(6).XStep = 2 : Figurenbestand(6).YStep = 1
Figurenbestand(7).Figurname="koenigin" : Figurenbestand(7).XStep = 2 : Figurenbestand(7).YStep = 1
Figurenbestand(8).Figurname="koenigbl" : Figurenbestand(8).XStep = 2 : Figurenbestand(8).YStep = 1
Figurenbestand(9).Figurname="arnolauf" : Figurenbestand(9).XStep = 2 : Figurenbestand(9).YStep = 1
Figurenbestand(10).Figurname="arnorenn" : Figurenbestand(10).XStep = 6 : Figurenbestand(10).YStep = 3


'---------------------------------------------------------------
SUB Figur(Was AS STRING, FigNr AS INTEGER, StartPosX AS INTEGER, StartPosY AS INTEGER, FigurDateiName AS STRING)
      STATIC AS STRING PaletteReturn, FGDummy, ImObjektAntwort
      STATIC AS STRING Bildname, SollBild
      STATIC AS ANY PTR Bildpalette
      STATIC AS ANY PTR Bildsicherung, Bildadresse
      STATIC AS INTEGER QuellStartX, QuellStartY, ZielStartX, ZielStartY, KopieBreite, KopieHoehe
      STATIC AS INTEGER Figurzaehler, RestZaehler, FigurInitFlag, Zaehler, QuellPosX, ZielPosX, ZielPosY, Taste
      STATIC AS INTEGER XRichtung, YRichtung, LinksKlickWarFigurFlag
      STATIC AS DOUBLE LetztGelaufenTimer, LaufSpeed, XSpeed, YSpeed
      DIM AS INTEGER TmpFigZaehler, ZeigZeile, SortFgNr, DateiBildBreit, DateiBildHoch, FreieDateiNummer
      '===============================================================
      'HAUPTTEIL
      '---------------------------------------------------------------
   SELECT CASE UCASE$(Was)
         CASE "FIGURENLOESCHEN"
               IF Protokollieren=1 THEN Protokoll("Figur: alle Figuren werden geloescht (1-" & STR(MaxFigur))
               FOR FigurZaehler=1 TO MaxFigur
                  IF FG(FigurZaehler).BildAdr <> 0 THEN
                      IMAGEDESTROY(FG(FigurZaehler).BildAdr)
                      FG(FigurZaehler).BildAdr = 0
                  END IF
               NEXT FigurZaehler
               ERASE FG
         CASE "FIGURENINIT"
               IF Protokollieren=1 THEN Protokoll("Figur: Erstelle Figuren (1-" & STR(MaxFigur))
               FOR FigurZaehler=1 TO MaxFigur
                        Zaehler = Rnd * (9 - 1) + 1 : 'Zufallszahl von 1 bis 9 ermitteln, mit der dann der Figur einen Namen geben
                        FG(FigurZaehler).Figurname = Figurenbestand(Zaehler).Figurname
                        FG(FigurZaehler).XStep  = Figurenbestand(Zaehler).XStep
                        FG(FigurZaehler).YStep  = Figurenbestand(Zaehler).YStep
                        FG(FigurZaehler).QStX   = 0
                        FG(FigurZaehler).QStY =   0
                        FG(FigurZaehler).LaufRchtg =  2
                        FG(FigurZaehler).FrameNr = ZufallsZahlen(0, 11) ' mit zuflligem Bild der 12-Bild-Ablauffolge beginnen
                        FG(FigurZaehler).FrameBreit = 48
                        FG(FigurZaehler).FrameHoch = 48
                        FG(FigurZaehler).FrameZahl = 11
                        FG(FigurZaehler).BildName="figure" & VZT & FG(FigurZaehler).Figurname & VZT & "2.bmp"
                        FG(FigurZaehler).SollBild = FG(FigurZaehler).BildName
                        IF FG(FigurZaehler).BildAdr <> 0 THEN : IMAGEDESTROY(FG(FigurZaehler).BildAdr) : FG(FigurZaehler).BildAdr = 0 : END IF
                        FG(FigurZaehler).BildAdr = IMAGECREATE( (FG(FigurZaehler).FrameZahl+1)*FG(FigurZaehler).FrameBreit, FG(FigurZaehler).FrameHoch, 0)
                        FG(FigurZaehler).WegQuelX = 0
                        FG(FigurZaehler).WegQuelY = 0
                        FG(FigurZaehler).WegZielX = 0
                        FG(FigurZaehler).WegZielY = 0
                        FG(FigurZaehler).LTimer = Timer
                        FG(FigurZaehler).RepSecs = 0.2
                        FG(FigurZaehler).IstAktiv = 0
                        FG(FigurZaehler).Sichtbar = 1
                        FG(FigurZaehler).InitFlag=1
                        FG(FigurZaehler).Breite =  48  : ' wir in Figur"LadeBild" ggf korrigiert
                        FG(FigurZaehler).Hoehe  =  48
                        IF RND > 0.5 THEN Figur("RichtungRechts", FigurZaehler, 0, 0, "") ELSE Figur("Richtunglinks", FigurZaehler, 0, 0, "")
                        IF RND > 0.5 THEN Figur("RichtungHoch", FigurZaehler, 0, 0, "") ELSE Figur("RichtungRunter", FigurZaehler, 0, 0, "")
                        Figur("LadeBild", FigurZaehler, 0, 0, "") : ' in der Ladebildroutine wird ggf Falsche Framezahl/Groesse korrigiert
                        ImObjektAntwort="9" : ' erst mal rein, damit folgendes DO UNTIL wirklich zur Schleife wird
'                        DO UNTIL ( ImObjektAntwort <> "9" AND ImObjektAntwort <> "3" AND ImbjektAntwort <> "1" AND ImObjektAntwort <> "7" )
                        DO WHILE ( INSTR("1379D", ImObjektAntwort) > 0 )
                           FG(FigurZaehler).ZStX   = LinkerLaufRand + FG(FigurZaehler).XStep + RND * HgBildBreite
                           IF FG(FigurZaehler).ZStX+FG(FigurZaehler).Breite > RechterLaufRand THEN FG(FigurZaehler).ZStX = LinkerLaufRand+1
                           FG(FigurZaehler).ZStY   = ObererLaufRand + FG(FigurZaehler).YStep + RND * HgBildHoehe
                           IF FG(FigurZaehler).ZStY+FG(FigurZaehler).Hoehe > UntererLaufRand THEN FG(FigurZaehler).ZStY = ObererLaufRand+FG(FigurZaehler).YStep+1
                           ImObjektAntwort = Objekt("IstPosImObjekt", 0, FG(FigurZaehler).ZStX-LinkerLaufrand+(FG(FigurZaehler).Breite\2), FG(FigurZaehler).ZStY-ObererLaufrand+(FG(FigurZaehler).Hoehe\2), FG(FigurZaehler).Breite\2, FigurZaehler, "")
                        LOOP
                        FG(FigurZaehler).QPosX  = FG(FigurZaehler).QStX
                        FG(FigurZaehler).QPosY  = FG(FigurZaehler).QStY
                        FG(FigurZaehler).ZPosX  = FG(FigurZaehler).ZStX
                        FG(FigurZaehler).ZPosY  = FG(FigurZaehler).ZStY
               NEXT FigurZaehler
         CASE "SCHNELLER"
               GesRepSecs = GesRepSecs -0.01
               IF GesRepSecs < 0.01 THEN GesRepSecs=0.01
         CASE "LANGSAMER"
               GesRepSecs = GesRepSecs +0.01
               IF GesRepSecs > GesMaxRepSecs THEN GesRepSecs=GesMaxRepSecs
         CASE "RICHTUNGLINKS"
               FG(FigNr).XRcht   = 0 - FG(FigNr).XStep
               IF FG(FigNr).YRcht > 0 THEN
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "3.bmp"
                  FG(FigNr).LaufRchtg = 3
               ELSE
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "4.bmp"
                  FG(FigNr).LaufRchtg = 4
               END IF
               Figur("LadeBild", FigNr, 0, 0, "")
         CASE "RICHTUNGRECHTS
               FG(FigNr).XRcht   = FG(FigNr).XStep
               IF FG(FigNr).YRcht > 0 THEN
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "2.bmp"
                  FG(FigNr).LaufRchtg = 2
               ELSE
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "1.bmp"
                  FG(FigNr).LaufRchtg = 1
               END IF
               Figur("LadeBild", FigNr, 0, 0, "")
         CASE "RICHTUNGHOCH"
               FG(FigNr).YRcht   = 0 - FG(FigNr).YStep
               IF FG(FigNr).XRcht > 0 THEN
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "1.bmp"
                  FG(FigNr).LaufRchtg = 1
               ELSE
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "4.bmp"
                  FG(FigNr).LaufRchtg = 4
               END IF
               Figur("LadeBild", FigNr, 0, 0, "")
         CASE "RICHTUNGRUNTER"
               FG(FigNr).YRcht   = FG(FigNr).YStep
               IF FG(FigNr).XRcht > 0 THEN
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "2.bmp"
                  FG(FigNr).LaufRchtg = 2
               ELSE
                  FG(FigNr).SollBild="figure" & VZT & FG(FigNr).Figurname & VZT & "3.bmp"
                  FG(FigNr).LaufRchtg = 3
               END IF
               Figur("LadeBild", FigNr, 0, 0, "")
         CASE "SETZXRICHTUNG
            FG(FigNr).XStep = StartPosX
               IF FG(FigNr).XRcht > 0 THEN FG(FigNr).XRcht = FG(FigNr).XStep ELSE FG(FigNr).XRcht = 0 - FG(FigNr).XStep
         CASE "SETZYRICHTUNG
            FG(FigNr).YStep = StartPosX
               IF FG(FigNr).YRcht > 0 THEN FG(FigNr).YRcht = FG(FigNr).YStep ELSE FG(FigNr).YRcht = 0 - FG(FigNr).YStep
         CASE "LADEBILD"
                     FreieDateiNummer=FREEFILE
                     Open FG(FigNr).SollBild FOR INPUT AS #FreieDateiNummer
                     IF LOF(FreieDateiNummer) > 0 THEN DateiExistiert = 1 ELSE DateiExistiert = 0
                        Get #FreieDateiNummer, 19, FG(FigNr).FrameBreit              'Breite aus der BMP-Datei auslesen
                        Get #FreieDateiNummer, 23, FG(FigNr).FrameHoch               'Hhe aus der BMP-Datei auslesen
                        IF FG(FigNr).FrameBreit<= 0 OR FG(FigNr).FrameHoch <= 0 THEN
                           PRINT "Figur(): Soll fuer Figur Nr: " & STR(FigNr) & " die Datei " & FG(FigNr).SollBild & " einlesen"
                           PRINT "Bildformat in Datei = " & STR(FG(FigNr).FrameBreit) & " X " & STR(FG(FigNr).FrameHoch) & ")"
                           PRINT "Einer der Werte ist auf Null, kann damit nicht arbeiten!"
                           PRINT "Jegliche Taste = Abbruch"
                           DO WHILE INKEY="" : LOOP
                           SYSTEM
                        END IF
                        FG(FigNr).FrameZahl=(FG(FigNr).FrameBreit \ FG(FigNr).FrameHoch)-1 'Hhe Film = auch Breite Bild somit Filmbreite : Hoehe = Bildzahl
                        FG(FigNr).FrameBreit = FG(FigNr).FrameHoch
                        FG(FigNr).Breite = FG(FigNr).FrameBreit
                        FG(FigNr).Hoehe  = FG(FigNr).FrameHoch
                     CLOSE #FreieDateiNummer
                     IF DateiExistiert = 1 THEN
                        FG(FigNr).BildName = FG(FigNr).SollBild
                        BLOAD(FG(FigNr).BildName, FG(FigNr).BildAdr)
                     ELSE
                        FGDummy = "(LadeBild) Soll der Figur Nr " & STR$(FigNr) & " die Bilddatei " & FG(FigNr).BildName & " zuordnen, Datei existiert jedoch nicht. Taste = weiter"
                        TEXT_Zentriert(FGDummy, 255)
                        FGDummy = readkey()
                     END IF
         CASE "WECHSLEBILD"
               FG(FigNr).FigurName = FigurDateiName
               FG(FigNr).SollBild  = "figure" & VZT & FG(FigNr).Figurname & "" & VZT & STR$(FG(FigNr).LaufRchtg) & ".bmp"
               Figur("LadeBild", FigNr, 0, 0, "")
         CASE "SICHTBAR"
               FG(FigNr).Sichtbar=0
         CASE "UNSICHTBAR"
               FG(FigNr).Sichtbar=1
         CASE "MACHAKTIV"
               'bisher Aktive Figur inaktiv schalten
               FG(AktiveFigur).IstAktiv=0
               FG(FigNr).IstAktiv=1
               AktiveFigur = FigNr
               FigurNr = FigNr
         CASE "MACHINAKTIV
               FG(FigNr).IstAktiv=0
               AktiveFigur = 0
               FigurNr = 0
         CASE "LAUFEINSCHRITT"
               IF Timer-GesLTimer > GesRepSecs THEN  : ' GESAMTTEMPO DES SPIELES (noch) ohne Bezug auf einzelne Figurtempos
                  GesLTimer=Timer
                  LetztStatistiktimer=Timer
                  'Hintergrundbild auf den Screen
                  SCREENLOCK
                  IF ZeigKollision=1 THEN
                      'durch Collisionsanzeige = gelbe Kreis, anzeige immer komplett neu aufbauen
                     'Bereich_Hintergrundbild_in_schwarz_anzeigen (Hintergrundbild hat transparente partien)
                     LINE (LinkerLaufRand, ObererLaufRand)-STEP(HgBildBreite-1,HgBildHoehe-1), RGB(0,0,0), BF
                     'HINTERGRUNDBILD IN SCREEN SETZEN
                     'Gesamter Leerer Hintergrund (ohne figuren) auf Screen
                     PUT (LinkerLaufRand, ObererLaufRand), Hintergrundbildpointer, (0,0) -STEP(HgAnzeigeBreite, HgAnzeigeHoehe), PSET :'TRANS :'
                  END IF
'                  --------------------------------------------------
                  FOR FigurZaehler=1 TO MaxFigur
                  '--------------------------------------------------
                        'an Bisheriger Figurposition den Leeren Hintergrund in Figurgroesse einblenden = Figur in Bild lschen
                        PUT (FG(FigurZaehler).ZPosX, FG(FigurZaehler).ZPosY), Hintergrundbildpointer, (FG(FigurZaehler).ZPosX-LinkerLaufrand, FG(FigurZaehler).ZPosY-ObererLaufRand)-STEP (FG(FigurZaehler).FrameBreit-1, FG(FigurZaehler).FrameHoch-1), PSET
                       'NAECHSTEN SCHRITT AUSRECHNEN
                        FG(FigurZaehler).FrameNr = FG(FigurZaehler).FrameNr + 1
                        IF FG(FigurZaehler).FrameNr > FG(FigurZaehler).FrameZahl THEN : FG(FigurZaehler).FrameNr = 0 : END IF
                        FG(FigurZaehler).QPosX = FG(FigurZaehler).QStX + FG(FigurZaehler).FrameNr * FG(FigurZaehler).FrameBreit
                        FG(FigurZaehler).ZPosX = FG(FigurZaehler).ZPosX + FG(FigurZaehler).XRcht
                        FG(FigurZaehler).ZPosY = FG(FigurZaehler).ZPosY + FG(FigurZaehler).YRcht
                       'PRFEN OB FIGUR UEBER RAND (re li ob un) RAUSLAEUFT, GGF NDERN
                        IF FG(FigurZaehler).ZPosX+FG(FigurZaehler).FrameBreit > RechterLaufRand THEN : Figur("RichtungLinks", FigurZaehler, 0, 0, "") : END IF
                        IF FG(FigurZaehler).ZPosY+FG(FigurZaehler).FrameHoch > UntererLaufRand THEN : Figur("RichtungHoch",  FigurZaehler, 0, 0, "") : END IF
                        IF FG(FigurZaehler).ZPosX <= LinkerLaufRand+1    THEN : Figur("RichtungRechts", FigurZaehler, 0, 0, "") : END IF
                        IF FG(FigurZaehler).ZPosY <= ObererLaufRand+1    THEN : Figur("RichtungRunter", FigurZaehler, 0, 0, "") : END IF
                        'PRUEFEN OB FIGUR IN EIN OBJEKT REIN LUFT
                        ImObjektAntwort = Objekt("IstPosImObjekt", 0, FG(FigurZaehler).ZPosX-LinkerLaufrand+(FG(FigurZaehler).Breite\2), FG(FigurZaehler).ZPosY-ObererLaufrand+(FG(FigurZaehler).Hoehe\2), FG(FigurZaehler).Breite\2, FigurZaehler, "")
                        SELECT CASE ImObjektAntwort
                           CASE "9"
                              'Das Objekt liegt nordoestlich von der geplanten Position der Figur
                              Figur("RichtungLinks", FigurZaehler, 0, 0, "")
                              Figur("RichtungRunter", FigurZaehler, 0, 0, "")
                           CASE "3"
                              'Das Objekt liegt suedoestlich von der geplanten Position der Figur
                              Figur("RichtungHoch", FigurZaehler, 0, 0, "")
                              Figur("Richtunglinks", FigurZaehler, 0, 0, "")
                           CASE "1"
                              'Das Objekt liegt suedwestlich von der geplanten Position der Figur
                              Figur("RichtungHoch", FigurZaehler, 0, 0, "")
                              Figur("RichtungRechts", FigurZaehler, 0, 0, "")
                           CASE "7"
                              'Das Objekt liegt nordwestlich von der geplanten Position der Figur
                              Figur("RichtungRunter", FigurZaehler, 0, 0, "")
                              Figur("RichtungRechts", FigurZaehler, 0, 0, "")
                           CASE "", "-"
                              'Mu Rein, damit in CaseElse nur nicht vorhergesehene Antworten von Objekt auflaufen
                           CASE ELSE
                              PRINT "figur()-Anzeigen: SelectCase kennt Antwort von IstPosImObjekt nicht, Antwort war:" & ImObjektAntwort
                        END SELECT
                        '--------------------------------------------------
                        'IN SortArray die YPos und die Array-Nummer der Figur reinschreiben
                        SortArray(FigurZaehler).ArrayPos = FigurZaehler
                        SortArray(FigurZaehler).ZPosY = FG(FigurZaehler).ZPosY + (FG(FigurZaehler).Hoehe\2) :'Zentrumspos der Figur nehmen, sieht besser aus
                  NEXT FigurZaehler
                  '--------------------------------------------------
                  'das Sortarray nach aufsteigender Y-Position sortieren
                  FOR FigurZaehler = 1 TO MaxFigur
                     FOR RestZaehler = Zaehler + 1 TO MaxFigur
                        IF SortArray(RestZaehler).ZPosY > SortArray(FigurZaehler).ZPosY THEN SWAP SortArray(RestZaehler), SortArray(FigurZaehler)
                     NEXT RestZaehler
                  NEXT FigurZaehler
                  '--------------------------------------------------
                  'Im SortArray stehen nun in nach YPos Aufsteigender Reihenfolge die Array-Nummern der Figuren
                  'in dieser Reihenfolge die Figuren Anzeigen (groessere Y = weiter vorne, also zuletzt zeigen)
                  FOR FigurZaehler=1 TO MaxFigur
                        'Nchstes Bild anzeigen
                        SortFgNr=SortArray(FigurZaehler).ArrayPos
                        PUT (FG(SortFgNr).ZPosX, FG(SortFgNr).ZPosY), FG(SortFgNr).BildAdr, (FG(SortFgNr).QPosX,FG(SortFgNr).QPosY)-STEP (FG(SortFgNr).FrameBreit-1, FG(SortFgNr).FrameHoch-1), TRANS
                        'falls die grad geblittete Figur die Aktive ist, Strich drueber
                        IF FG(SortFgNr).IstAktiv = 1 THEN
                           LINE (FG(SortFgNr).ZPosX+2, FG(SortFgNr).ZPosY+1) - STEP (FG(SortFgNr).Breite-4, 0), 255
                           LINE (FG(SortFgNr).ZPosX+2, FG(SortFgNr).ZPosY+2) - STEP (FG(SortFgNr).Breite-4, 0), 255
                        END IF
                        IF ZeigLaufNummer=1 THEN
                           'UND Lauf-NUMMER DRUNTER
                           PrintString(STR(SortFgNr),FG(SortFgNr).ZPosX+3,FG(SortFgNr).ZPosY+3,RGB(255,255,255), 0, 0)
                        END IF
                  NEXT FigurZaehler
                  '--------------------------------------------------
                  'Rechts unten in Ecke statistischer Zeitverbrauch einmal Bildwechsel fr alle figuren
                  'sowie Auflsung und Eingestellte Wartezeit frames anzeigen
                  StatistikTimeSchnitt = ((StatistikTimeZahl * StatistikTimeSchnitt) + (Timer-LetztStatistiktimer)) / (StatistikTimeZahl+1)
                  IF StatistikTimeZahl < 20 THEN StatistikTimeZahl = StatistikTimeZahl + 1
                  FGDummy = STR(MaxFigur) & " Figuren ein Frame anzeigen: " & FORMAT(StatistikTimeSchnitt, "#,####0.0000") & " sec"
                  LINE (10,VarScreen_H-14)-(VarScreen_W-10,VarScreen_H-2), RGB(48,0,0), BF
                  PrintString(FGDummy, 12,VarScreen_H-14,RGB(255,128,48),2, 0)
                  FGDummy = STR(FbGfxBreite) & "x" & STR(FbGfxHoehe) & "x" & STR(FbGfxTiefe)
                  PrintString(FGDummy, 380,VarScreen_H-12,RGB(0,255,0),2, 0)
                  FGDummy = FORMAT(GesRepSecs, "#,##0.00") & " secs warten"
                  PrintString(FGDummy, 510,VarScreen_H-12,RGB(128,128,255),2, 0)
                  SCREENUNLOCK
               END IF
'               --------------------------------------------------
         CASE "PRINTREPEAT" : ' hinfllig, wird unten rechts sowieso schon angezeigt
               FGDummy = "GesRepSecs=" & STR$(GesRepSecs*100)
               IF LEN(FGDummy) > 14 THEN FGDummy = left$(FGDummy, 14)
               IF LEN(FGDummy) < 14 THEN FGDummy = FGDummy & STRING( 14-LEN(FGDummy), "M")
               textout_centre(screen,font, FGDummy, VarSCREEN_W\2, VarSCREEN_H-30, 255)
         CASE "LINKSKLICK"
               'Bei Linksklick hier prfen, ob eine Figur angeklickt ist, ggf. Aktive Figur darauf setzen
                  LinksKlickWarFigurFlag = 0
                  FOR FigurZaehler=1 TO MaxFigur
                        'Nchstes Bild anzeigen
                        SortFgNr=SortArray(FigurZaehler).ArrayPos
                        'falls die grad zu prfende Figur eine Aktive ist, inaktiv setzen
                        '(war ja Linksklick, falls Figur wird die weiter unten aktiv, falls keine Figur, soll auch keine aktiv sein)
                        IF FG(SortFgNr).IstAktiv = 1 THEN FG(SortFgNr).IstAktiv = 0
                        IF LinksKlickWarFigurFlag = 0 THEN
                           IF MausX >= FG(SortFgNr).ZPosX AND MausX <= FG(SortFgNr).ZPosX + FG(SortFgNr).FrameBreit AND MausY >= FG(SortFgNr).ZPosY AND MausY <= FG(SortFgNr).ZPosY + FG(SortFgNr).FrameHoch THEN
                              'Mausklick war in Figur FG(SortFgNr) und es ist durch Klick noch keine Figur aktiviert
'                              FG(SortFgNr).IstAktiv = 1 'nur eine Figur aktivieren
'                              AktiveFigur = SortFgNr
                               Figur("MachAktiv", SortFgNr, 0, 0, "")
                              LinksKlickWarFigurFlag = 1
                           END IF
                        END IF
                  NEXT FigurZaehler
                  LinksKlickWarFigurFlag = 0
         CASE ELSE
               FGDummy = "SelectCase in Figur-Sub kennt folgende Aufgabe nicht: " & Was
               TEXT_Zentriert(FGDummy,255)
   END SELECT

END SUB
'---------------------------------------------------------------